diff --git a/sound/drivers/upisnd/upisnd_protocol.h b/sound/drivers/upisnd/upisnd_protocol.h
new file mode 100644
index 000000000000..59beaa3e6cbf
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_protocol.h
@@ -0,0 +1,323 @@
+/* SPDX-License-Identifier: GPL-2.0-only */
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef UPISND_PROTOCOL_H
+#define UPISND_PROTOCOL_H
+
+#ifndef __KERNEL__
+#include <stdint.h>
+#include <stdbool.h>
+
+enum upisnd_irq_type_e {
+	IRQ_TYPE_NONE         = 0,
+	IRQ_TYPE_EDGE_RISING  = 1,
+	IRQ_TYPE_EDGE_FALLING = 2,
+	IRQ_TYPE_EDGES_BOTH   = 3,
+};
+#endif
+
+enum { UPISND_ON_BIT_MASK  = 0x80 };
+enum { UPISND_IRQ_NUM_MASK = 0x7f };
+enum { UPISND_PIN_MASK     = 0x3f };
+
+enum upisnd_irq_num_e {
+	UPISND_IRQ_GPIO_START       = 0,
+	// IRQ numbers match GPIO numbers.
+	UPISND_IRQ_GPIO_END         = UPISND_PIN_MASK,
+
+	UPISND_IRQ_VGND_SHORT_ALERT = 0x7f,
+};
+
+typedef u8 upisnd_pin_t;
+typedef u8 upisnd_irq_num_t;
+typedef u8 upisnd_msg_id_t;
+
+typedef u32 upisnd_setup_t;
+
+enum upisnd_activity_type_e {
+	UPISND_ACTIVITY_TYPE_MIDI_IN  = 0,
+	UPISND_ACTIVITY_TYPE_MIDI_OUT = 1,
+};
+
+enum upisnd_pin_pull_e {
+	UPISND_PIN_PULL_NONE = 0,
+	UPISND_PIN_PULL_UP   = 1,
+	UPISND_PIN_PULL_DOWN = 2
+};
+
+enum upisnd_pin_direction_e {
+	UPISND_PIN_DIR_INPUT  = 0,
+	UPISND_PIN_DIR_OUTPUT = 1
+};
+
+enum upisnd_element_type_e {
+	UPISND_ELEMENT_TYPE_NONE          = 0,
+	UPISND_ELEMENT_TYPE_ENCODER       = 1,
+	UPISND_ELEMENT_TYPE_ANALOG_IN     = 2,
+	UPISND_ELEMENT_TYPE_GPIO          = 3,
+	UPISND_ELEMENT_TYPE_ACTIVITY      = 4,
+};
+
+#define UPISND_DEFINE_SETUP_FIELD(shift, bits, type, name) \
+	static inline type upisnd_setup_get_ ## name(upisnd_setup_t setup) \
+	{ \
+		return (type)(((setup) & (((1 << (bits)) - 1) << (shift))) >> (shift)); \
+	} \
+	static inline void upisnd_setup_set_ ## name(upisnd_setup_t *setup, type value) \
+	{ \
+		*(setup) = ((*(setup)) & ~(((1 << (bits)) - 1) << (shift))) | \
+			 (((value) & ((1 << (bits)) - 1)) << (shift)); \
+	}
+
+UPISND_DEFINE_SETUP_FIELD(0, 3, enum upisnd_element_type_e, element_type);
+UPISND_DEFINE_SETUP_FIELD(3, 8, upisnd_pin_t, pin_id);
+UPISND_DEFINE_SETUP_FIELD(11, 2, enum upisnd_pin_pull_e, gpio_pull);
+UPISND_DEFINE_SETUP_FIELD(13, 1, enum upisnd_pin_direction_e, gpio_dir);
+UPISND_DEFINE_SETUP_FIELD(12, 1, bool, gpio_output);
+UPISND_DEFINE_SETUP_FIELD(13, 8, upisnd_pin_t, encoder_pin_b_id);
+UPISND_DEFINE_SETUP_FIELD(21, 2, enum upisnd_pin_pull_e, encoder_pin_b_pull);
+UPISND_DEFINE_SETUP_FIELD(11, 2, enum upisnd_activity_type_e, activity_type);
+
+#undef UPISND_DEFINE_SETUP_FIELD
+
+struct upisnd_irq_type_config_t {
+	u8 irq_types[10];
+} __packed;
+
+static inline void upisnd_irq_config_set_irq_type(struct upisnd_irq_type_config_t *cfg,
+						  upisnd_pin_t pin,
+						  unsigned int type)
+{
+	u8 *d = &cfg->irq_types[pin >> 2];
+	*d = (*d & ~(0x3 << (pin & 0x3))) | ((type & 0x3) << (pin & 0x3));
+}
+
+static inline unsigned int upisnd_irq_config_get_irq_type(const struct upisnd_irq_type_config_t
+							  *cfg, upisnd_pin_t pin)
+{
+	return (cfg->irq_types[pin >> 2] >> (pin & 0x3)) & 0x3;
+}
+
+struct upisnd_irq_mask_config_t {
+	u8 irq_mask[5];
+} __packed;
+
+static inline void upisnd_irq_mask_config_set(struct upisnd_irq_mask_config_t *cfg,
+					      upisnd_pin_t pin,
+					      bool mask)
+{
+	u8 *d = &cfg->irq_mask[pin >> 3];
+
+	if (mask)
+		*d |= 1 << (pin & 0x7);
+	else
+		*d &= ~(1 << (pin & 0x7));
+}
+
+static inline bool upisnd_irq_mask_config_get(const struct upisnd_irq_mask_config_t *cfg,
+					      upisnd_pin_t pin)
+{
+	return (cfg->irq_mask[pin >> 3] & (1 << (pin & 0x7))) != 0;
+}
+
+struct upisnd_all_gpio_state_t {
+	u8 state[5];
+} __packed;
+
+enum { UPISND_MAX_PACKET_LENGTH   = 16   };
+enum { UPISND_MSG_RESPONSE_FLAG   = 0x80 };
+enum { UPISND_MSG_ID_MASK         = 0x7f };
+enum { UPISND_MSG_ID_INVALID      = 0x00 };
+
+enum upisnd_cmd_type_e {
+	UPISND_CMD_MIDI               = 0x00,
+	UPISND_CMD_SETUP              = 0x10,
+	UPISND_CMD_SET_IRQ_TYPES      = 0x20,
+	UPISND_CMD_SET_IRQ_MASKS      = 0x30,
+	UPISND_CMD_SET_GPIO           = 0x40,
+	UPISND_CMD_GET_GPIO           = 0x50,
+	UPISND_CMD_SET_ALL_GPIOS      = 0x60,
+	UPISND_CMD_GET_ALL_GPIOS      = 0x70,
+	UPISND_CMD_RESULT             = 0x80,
+	UPISND_CMD_SET_SUBSCRIPTION   = 0x90,
+	UPISND_CMD_IRQ_EVENT          = 0xa0,
+	UPISND_CMD_GET                = 0xb0,
+	UPISND_CMD_SET                = 0xc0,
+	UPISND_CMD_CONTROL_EVENT      = 0xd0,
+
+	UPISND_CMD_INVALID            = 0xff
+};
+
+enum { UPISND_CMD_TYPE_MASK       = 0xf0 };
+enum { UPISND_CMD_LENGTH_MASK     = 0x0f };
+
+enum upisnd_value_id_t {
+	UPISND_VALUE_INVALID          = 0x00,
+	UPISND_VALUE_VERSION_INFO     = 0x01,
+	UPISND_VALUE_ADC_OFFSET       = 0x02,
+	UPISND_VALUE_ADC_GAIN         = 0x03,
+	UPISND_VALUE_SERIAL_NUMBER    = 0x04,
+	UPISND_VALUE_ELEMENT_VAL_BASE = 0x80,
+};
+
+struct upisnd_cmd_t {
+	u8             cmd_and_size;
+	u8             flags_and_msg_id;
+} __packed;
+
+static inline bool upisnd_cmd_is_response(const struct upisnd_cmd_t *cmd)
+{
+	return (cmd->flags_and_msg_id & UPISND_MSG_RESPONSE_FLAG) != 0;
+}
+
+struct upisnd_cmd_setup_t {
+	struct upisnd_cmd_t cmd;
+	upisnd_setup_t      setup;
+} __packed;
+
+struct upisnd_cmd_set_gpio_t {
+	u8             cmd_and_size;
+	u8             on_and_pin;
+} __packed;
+
+struct upisnd_cmd_get_gpio_t {
+	struct upisnd_cmd_t cmd;
+	u8             pin;
+} __packed;
+
+struct upisnd_cmd_set_all_gpios_t {
+	u8                        cmd_and_size;
+	struct upisnd_all_gpio_state_t state;
+} __packed;
+
+struct upisnd_cmd_get_all_gpios_t {
+	struct upisnd_cmd_t            cmd;
+} __packed;
+
+struct upisnd_cmd_get_all_gpios_response_t {
+	struct upisnd_cmd_t            cmd;
+	struct upisnd_all_gpio_state_t state;
+} __packed;
+
+struct upisnd_cmd_set_irq_types_t {
+	struct upisnd_cmd_t             cmd;
+	struct upisnd_irq_type_config_t config;
+} __packed;
+
+struct upisnd_cmd_set_irq_masks_t {
+	struct upisnd_cmd_t             cmd;
+	struct upisnd_irq_mask_config_t config;
+} __packed;
+
+struct upisnd_cmd_set_subscription_t {
+	struct upisnd_cmd_t cmd;
+	u8             on_and_irq_num;
+} __packed;
+
+struct upisnd_cmd_result_t {
+	struct upisnd_cmd_t cmd;
+	s8              result;
+} __packed;
+
+struct upisnd_cmd_get_t {
+	struct upisnd_cmd_t cmd;
+	u8             value_id;
+} __packed;
+
+enum { UPISND_CMD_GET_RESPONSE_INT32_SIZE    = sizeof(struct upisnd_cmd_get_t) + sizeof(int8_t) +
+					       sizeof(int32_t) };
+enum { UPISND_CMD_GET_RESPONSE_DATA_MIN_SIZE = sizeof(struct upisnd_cmd_get_t) + sizeof(int8_t) };
+
+struct upisnd_cmd_get_response_t {
+	struct upisnd_cmd_get_t cmd_get;
+	s8                  result;
+	union {
+		s32             value;
+		u8             data[12];
+	};
+} __packed;
+
+struct upisnd_cmd_set_t {
+	struct upisnd_cmd_t cmd;
+	u8             value_id;
+	s32             value;
+} __packed;
+
+struct upisnd_cmd_control_event_t {
+	u8             cmd_and_size;
+	u16            values[7];
+} __packed;
+
+static inline enum upisnd_cmd_type_e upisnd_cmd_decode_type(u8 b)
+{
+	return (enum upisnd_cmd_type_e)(b & UPISND_CMD_TYPE_MASK);
+}
+
+static inline u8 upisnd_cmd_decode_length(u8 b)
+{
+	return (b & UPISND_CMD_LENGTH_MASK) + 1u;
+}
+
+static inline u8 upisnd_cmd_encode(enum upisnd_cmd_type_e type, u8 size)
+{
+	return (size <= UPISND_MAX_PACKET_LENGTH && size > 0) ? (type | (size - 1))
+		: UPISND_CMD_INVALID;
+}
+
+static inline u8 upisnd_msg_id_encode(upisnd_msg_id_t msg_id, bool response)
+{
+	return (response ? 0x80 : 0x00) | (msg_id & UPISND_MSG_ID_MASK);
+}
+
+static inline upisnd_msg_id_t upisnd_msg_id_decode_id(u8 b)
+{
+	return b & UPISND_MSG_ID_MASK;
+}
+
+static inline void upisnd_cmd_prepare(struct upisnd_cmd_t *cmd,
+				      enum upisnd_cmd_type_e type,
+				      u8 size,
+				      upisnd_msg_id_t msg_id,
+				      bool response)
+{
+	cmd->cmd_and_size = upisnd_cmd_encode(type, size);
+	cmd->flags_and_msg_id = upisnd_msg_id_encode(msg_id, response);
+}
+
+#define upisnd_cmd_matches(_cmd, type, size) \
+	(upisnd_cmd_decode_type((_cmd)->cmd_and_size) == (type) && \
+	upisnd_cmd_decode_length((_cmd)->cmd_and_size) >= (size))
+
+static inline bool upisnd_cmd_type_has_msg_id(enum upisnd_cmd_type_e type)
+{
+	switch (type) {
+	default:
+		return false;
+	case UPISND_CMD_SETUP:
+	case UPISND_CMD_SET_IRQ_TYPES:
+	case UPISND_CMD_SET_IRQ_MASKS:
+	case UPISND_CMD_GET_GPIO:
+	case UPISND_CMD_GET_ALL_GPIOS:
+	case UPISND_CMD_RESULT:
+	case UPISND_CMD_GET:
+	case UPISND_CMD_SET:
+		return true;
+	}
+}
+
+#endif // UPISND_PROTOCOL_H
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_sound.c b/sound/drivers/upisnd/upisnd_sound.c
new file mode 100644
index 000000000000..69188a0f43d3
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_sound.c
@@ -0,0 +1,277 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "upisnd_common.h"
+#include "upisnd_codec.h"
+
+static void upisnd_proc_serial_show(struct snd_info_entry *entry, struct snd_info_buffer *buffer)
+{
+	struct upisnd_instance *instance = entry->private_data;
+
+	snd_iprintf(buffer, "%s\n", instance->ctrl.serial);
+}
+
+static void upisnd_proc_version_show(struct snd_info_entry *entry, struct snd_info_buffer *buffer)
+{
+	struct upisnd_instance *instance = entry->private_data;
+
+	snd_iprintf(buffer,
+		    "%u.%u.%u\n",
+		    instance->ctrl.version.major,
+		    instance->ctrl.version.minor,
+		    instance->ctrl.version.build);
+}
+
+static void upisnd_proc_hwrev_show(struct snd_info_entry *entry, struct snd_info_buffer *buffer)
+{
+	struct upisnd_instance *instance = entry->private_data;
+
+	snd_iprintf(buffer, "%u\n", instance->ctrl.version.hwrev);
+}
+
+static int upisnd_card_probe(struct snd_soc_card *card)
+{
+	struct upisnd_instance *instance = container_of(card, struct upisnd_instance, sound_card);
+	int err;
+
+	err = upisnd_midi_init(instance);
+
+	if (err < 0) {
+		printe("Failed to initialize MIDI subsystem! (%d)", err);
+		return err;
+	}
+
+	err = snd_card_ro_proc_new(card->snd_card, "serial", instance, upisnd_proc_serial_show);
+
+	if (err < 0) {
+		printe("Failed to create serial proc entry! (%d)", err);
+		return err;
+	}
+
+	err = snd_card_ro_proc_new(card->snd_card, "version", instance, upisnd_proc_version_show);
+
+	if (err < 0) {
+		printe("Failed to create version proc entry! (%d)", err);
+		return err;
+	}
+
+	err = snd_card_ro_proc_new(card->snd_card, "hwrev", instance, upisnd_proc_hwrev_show);
+
+	if (err < 0) {
+		printe("Failed to create hwrev proc entry! (%d)", err);
+		return err;
+	}
+
+	return 0;
+}
+
+static int upisnd_card_remove(struct snd_soc_card *card)
+{
+	struct upisnd_instance *instance = container_of(card, struct upisnd_instance, sound_card);
+
+	upisnd_midi_uninit(instance);
+	return 0;
+}
+
+static int upisnd_startup(struct snd_pcm_substream *substream)
+{
+	printd("startup");
+	return 0;
+}
+
+static int upisnd_hw_params(struct snd_pcm_substream *substream, struct snd_pcm_hw_params *params)
+{
+	printd("hw_params");
+
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+
+	struct snd_soc_dai *cpu_dai = snd_soc_rtd_to_cpu(rtd, 0);
+	int ret = 0;
+
+	struct upisnd_instance *instance = container_of(rtd->card,
+							struct upisnd_instance,
+							sound_card);
+
+	if (!(instance->flags & UPISND_FLAG_DUMMY))
+		ret = snd_soc_dai_set_bclk_ratio(cpu_dai, 64);
+
+	if (ret < 0) {
+		printe("Failed setting dai bclk ratio!\n");
+		return ret;
+	}
+
+	return 0;
+}
+
+static int upisnd_dai_init(struct snd_soc_pcm_runtime *rtd)
+{
+	struct snd_soc_dai *codec_dai = snd_soc_rtd_to_codec(rtd, 0);
+
+	return snd_soc_dai_set_tdm_slot(codec_dai, 0, 0, 0, 0); // Enable I2S mode.
+}
+
+static const struct snd_soc_ops upisnd_ops = {
+	.startup = upisnd_startup,
+	.hw_params = upisnd_hw_params,
+};
+
+SND_SOC_DAILINK_DEFS(adau1961,
+		     DAILINK_COMP_ARRAY(COMP_EMPTY()),
+	DAILINK_COMP_ARRAY(COMP_CODEC("adau1961", "adau-hifi")),
+	DAILINK_COMP_ARRAY(COMP_EMPTY()));
+
+static const struct snd_soc_dai_link upisnd_dai_link = {
+	.name = "pisound-micro",
+	.stream_name = "pisound-micro PCM",
+	.dai_fmt =
+		SND_SOC_DAIFMT_I2S |
+		SND_SOC_DAIFMT_NB_NF |
+		SND_SOC_DAIFMT_CBM_CFM,
+	.ops = &upisnd_ops,
+	.init = upisnd_dai_init,
+	SND_SOC_DAILINK_REG(adau1961),
+};
+
+static const struct snd_soc_card upisnd_sound_card = {
+	.name = "pisoundmicro",
+	.owner = THIS_MODULE,
+	.probe = upisnd_card_probe,
+	.remove = upisnd_card_remove,
+};
+
+int upisnd_sound_init(struct platform_device *pdev, struct upisnd_instance *instance)
+{
+	struct snd_soc_dai_link_component *comp = NULL;
+	struct device_node *i2s_node = NULL;
+
+	memcpy(&instance->sound_card, &upisnd_sound_card, sizeof(upisnd_sound_card));
+	memcpy(&instance->dai_link, &upisnd_dai_link, sizeof(upisnd_dai_link));
+
+	if (pdev->dev.of_node) {
+		of_property_read_string(pdev->dev.of_node, "card-name", &instance->sound_card.name);
+		i2s_node = of_parse_phandle(pdev->dev.of_node, "i2s-controller", 0);
+		if (!i2s_node)
+			printi("'i2s-controller' node not specified, will use dummy one instead!");
+	}
+
+	comp = devm_kzalloc(&pdev->dev, sizeof(*comp) * 3, GFP_KERNEL);
+	if (!comp)
+		return -ENOMEM;
+
+	char *long_name = devm_kzalloc(&pdev->dev, 26, GFP_KERNEL);
+
+	if (!long_name)
+		return -ENOMEM;
+
+	instance->dai_link.cpus = &comp[0];
+	instance->dai_link.codecs = &comp[1];
+	instance->dai_link.platforms = &comp[2];
+
+	instance->dai_link.num_cpus = 1;
+	instance->dai_link.num_codecs = 1;
+	instance->dai_link.num_platforms = 1;
+
+	if (i2s_node) {
+		instance->dai_link.cpus->of_node = i2s_node;
+		instance->dai_link.platforms->of_node = i2s_node;
+	} else {
+		printi("Setting up dummy interface.");
+		instance->dai_link.cpus->name = "snd-soc-dummy";
+		instance->dai_link.platforms->name = "snd-soc-dummy";
+		instance->dai_link.cpus->dai_name = "snd-soc-dummy-dai";
+		instance->dai_link.platforms->dai_name = "snd-soc-dummy-dai";
+		instance->dai_link.dai_fmt = (instance->dai_link.dai_fmt & ~SND_SOC_DAIFMT_CBM_CFM)
+					     | SND_SOC_DAIFMT_CBS_CFS;
+		instance->flags |= UPISND_FLAG_DUMMY;
+	}
+	instance->dai_link.codecs->of_node = instance->codec_dev->of_node;
+	instance->dai_link.codecs->dai_name = "adau-hifi";
+	instance->dai_link.stream_name = instance->ctrl.serial;
+
+	instance->sound_card.dev = &pdev->dev;
+
+	instance->sound_card.dai_link = &instance->dai_link;
+	instance->sound_card.num_links = 1;
+
+	snprintf(long_name, 26, "Pisound Micro %s", instance->ctrl.serial);
+	instance->sound_card.long_name = long_name;
+	printd("About to register card %s", instance->sound_card.long_name);
+
+	int err = snd_soc_register_card(&instance->sound_card);
+
+	if (i2s_node)
+		of_node_put(i2s_node);
+
+	if (err < 0) {
+		instance->sound_card.dev = NULL;
+		if (err != -EPROBE_DEFER)
+			printe("snd_soc_register_card failed with %d!", err);
+		return err;
+	}
+
+	struct snd_soc_dai *dai = snd_soc_card_get_codec_dai(&instance->sound_card, "adau-hifi");
+
+	if (!dai) {
+		printe("Failed to get codec dai!");
+		instance->sound_card.dev = NULL;
+		return -ENODEV;
+	}
+
+	if (adau1961_is_hp_capless(dai->component)) {
+		err = upisnd_comm_set_subscription(instance, UPISND_IRQ_VGND_SHORT_ALERT, true);
+		if (err < 0) {
+			instance->sound_card.dev = NULL;
+			printe("Failed to subscribe to VGND short alert IRQ! (%d)", err);
+			return err;
+		}
+	}
+
+	return 0;
+}
+
+static void upisnd_sound_handle_irq_event(struct upisnd_instance *instance,
+					  const struct irq_event_t *event)
+{
+	struct snd_soc_dai *dai = NULL;
+
+	switch (event->num) {
+	case UPISND_IRQ_VGND_SHORT_ALERT:
+		dai = snd_soc_card_get_codec_dai(&instance->sound_card, "adau-hifi");
+		printe("VGND short alert %s Headphone output!",
+		       event->high ? "ON, muting" : "OFF, restoring last state");
+		if (dai)
+			adau1961_set_vgnd_shorted(dai->component, event->high);
+		else
+			printe("Failed to get codec dai!");
+		break;
+	default:
+		break;
+	}
+}
+
+void upisnd_sound_handle_irq_events(struct upisnd_instance *instance,
+				    const struct irq_event_t *events,
+				    unsigned int n)
+{
+	unsigned int i;
+
+	printd("Handling %u sound IRQ events", n);
+
+	for (i = 0; i < n; ++i)
+		upisnd_sound_handle_irq_event(instance, &events[i]);
+}
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_sound.h b/sound/drivers/upisnd/upisnd_sound.h
new file mode 100644
index 000000000000..100f30733ba2
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_sound.h
@@ -0,0 +1,28 @@
+/* SPDX-License-Identifier: GPL-2.0-only */
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef UPISOUND_SOUND_H
+#define UPISOUND_SOUND_H
+
+int upisnd_sound_init(struct platform_device *pdev, struct upisnd_instance *instance);
+
+void upisnd_sound_handle_irq_events(struct upisnd_instance *instance,
+				    const struct irq_event_t *events,
+				    unsigned int n);
+
+#endif // UPISOUND_SOUND_H
+
+/* vim: set ts=8 sw=8 noexpandtab: */
